diff --git a/build-support/build_postgres b/build-support/build_postgres
index 84991bdddff6..b98d01dcecb9 100755
--- a/build-support/build_postgres
+++ b/build-support/build_postgres
@@ -21,6 +21,7 @@ if [[ -z ${YB_BUILD_ROOT:-} ]]; then
 fi
 export BUILD_ROOT=$YB_BUILD_ROOT
 predefined_build_root=${YB_BUILD_ROOT}
+handle_predefined_build_root_quietly=true
 handle_predefined_build_root
 
 activate_virtualenv
diff --git a/build-support/common-build-env.sh b/build-support/common-build-env.sh
index 76a358bceab1..a9ad1144a27f 100644
--- a/build-support/common-build-env.sh
+++ b/build-support/common-build-env.sh
@@ -1984,7 +1984,7 @@ handle_predefined_build_root() {
 
   if [[ -z ${build_type:-} ]]; then
     build_type=$_build_type
-    if ! "$handle_predefined_build_root_quietly"; then
+    if [[ ${handle_predefined_build_root_quietly} == "false" ]]; then
       log "Setting build type to '$build_type' based on predefined build root ('$basename')"
     fi
     validate_build_type "$build_type"
@@ -1995,7 +1995,7 @@ handle_predefined_build_root() {
 
   if [[ -z ${YB_COMPILER_TYPE:-} ]]; then
     export YB_COMPILER_TYPE=$_compiler_type
-    if ! "$handle_predefined_build_root_quietly"; then
+    if [[ ${handle_predefined_build_root_quietly} == "false" ]]; then
       log "Automatically setting compiler type to '$YB_COMPILER_TYPE' based on predefined build" \
           "root ('$basename')"
     fi
@@ -2006,7 +2006,7 @@ handle_predefined_build_root() {
 
   if [[ -z ${YB_LINKING_TYPE:-} ]]; then
     export YB_LINKING_TYPE=$_linking_type
-    if ! "$handle_predefined_build_root_quietly"; then
+    if [[ ${handle_predefined_build_root_quietly} == "false" ]]; then
       log "Automatically setting linking type to '$YB_LINKING_TYPE' based on predefined build" \
           "root ('$basename')"
     fi
diff --git a/cmake_modules/YugabyteTesting.cmake b/cmake_modules/YugabyteTesting.cmake
index ae4f773b54b2..6f72217046aa 100644
--- a/cmake_modules/YugabyteTesting.cmake
+++ b/cmake_modules/YugabyteTesting.cmake
@@ -239,26 +239,3 @@ function(ADD_YB_TEST_LIBRARY LIB_NAME)
     add_dependencies(${LIB_NAME} ${ARG_NONLINK_DEPS})
   endif()
 endfunction()
-
-macro(yb_disable_tests_if_necessary)
-  if(NOT "$ENV{YB_DO_NOT_BUILD_TESTS}" STREQUAL "")
-    if("$ENV{YB_DO_NOT_BUILD_TESTS}" STREQUAL "1")
-      message("YB_DO_NOT_BUILD_TESTS is set to 1, will not build tests")
-      set(BUILD_TESTS OFF)
-    elseif("$ENV{YB_DO_NOT_BUILD_TESTS}" STREQUAL "0")
-      message("YB_DO_NOT_BUILD_TESTS is set to 0, will build tests")
-      set(BUILD_TESTS ON)
-    else()
-      message(FATAL_ERROR
-              "Invalid value of the YB_DO_NOT_BUILD_TESTS environment variable, expected 0 or 1 but"
-              " got '$ENV{YB_DO_NOT_BUILD_TESTS}'.")
-    endif()
-    set(BUILD_TESTS ${BUILD_TESTS} CACHE BOOL "Whether to build tests")
-  elseif("$CACHE{BUILD_TESTS}" STREQUAL "")
-    set(BUILD_TESTS ON)
-    message("Will build tests by default")
-  else()
-    message(
-      "BUILD_TESTS from cache: ${BUILD_TESTS} (set YB_DO_NOT_BUILD_TESTS to 0 or 1 to change)")
-  endif()
-endmacro()
diff --git a/python/yb/build_postgres.py b/python/yb/build_postgres.py
index a1eabc2d5877..1a6a908983f0 100755
--- a/python/yb/build_postgres.py
+++ b/python/yb/build_postgres.py
@@ -890,14 +890,6 @@ def build_postgres(self) -> None:
             self.clean_postgres()
 
         mkdir_p(self.pg_build_root)
-        if self.should_configure:
-            # Regardless of build stamp, the postgres code in src should be synced to the code in
-            # build.  It's fine to do this only for the configure step because the make step depends
-            # on the configure step as defined in src/postgres/CMakeLists.txt.
-            with WorkDirContext(self.pg_build_root):
-                self.sync_postgres_source()
-
-        self.set_env_vars('configure')
         saved_build_stamp = self.get_saved_build_stamp()
         initial_build_stamp = self.get_build_stamp(include_env_vars=True)
         initial_build_stamp_no_env = self.get_build_stamp(include_env_vars=False)
@@ -915,6 +907,15 @@ def build_postgres(self) -> None:
                     self.pg_build_root, self.steps_description())
                 return
 
+        if self.should_configure:
+            # Regardless of build stamp, the postgres code in src should be synced to the code in
+            # build.  It's fine to do this only for the configure step because the make step depends
+            # on the configure step as defined in src/postgres/CMakeLists.txt.
+            with WorkDirContext(self.pg_build_root):
+                self.sync_postgres_source()
+
+        self.set_env_vars('configure')
+
         with WorkDirContext(self.pg_build_root):
             if self.should_configure:
                 configure_start_time_sec = time.time()
diff --git a/src/yb/docdb/doc_write_batch.cc b/src/yb/docdb/doc_write_batch.cc
index 8f2ebe12033e..fc8b13ea983c 100644
--- a/src/yb/docdb/doc_write_batch.cc
+++ b/src/yb/docdb/doc_write_batch.cc
@@ -823,43 +823,40 @@ void DocWriteBatch::TEST_CopyToWriteBatchPB(LWKeyValueWriteBatchPB *kv_pb) const
 // Converting a RocksDB write batch to a string.
 // ------------------------------------------------------------------------------------------------
 
-class DocWriteBatchFormatter : public WriteBatchFormatter {
- public:
-  DocWriteBatchFormatter(
-      StorageDbType storage_db_type,
-      BinaryOutputFormat binary_output_format,
-      WriteBatchOutputFormat batch_output_format,
-      std::string line_prefix)
-      : WriteBatchFormatter(binary_output_format, batch_output_format, std::move(line_prefix)),
-        storage_db_type_(storage_db_type) {}
- protected:
-  std::string FormatKey(const Slice& key) override {
-    const auto key_result = DocDBKeyToDebugStr(key, storage_db_type_);
-    if (key_result.ok()) {
-      return *key_result;
-    }
-    return Format(
-        "$0 (error: $1)",
-        WriteBatchFormatter::FormatKey(key),
-        key_result.status());
-  }
-
-  std::string FormatValue(const Slice& key, const Slice& value) override {
-    auto key_type = GetKeyType(key, storage_db_type_);
-    const auto value_result = DocDBValueToDebugStr(
-        key_type, key, value, SchemaPackingStorage());
-    if (value_result.ok()) {
-      return *value_result;
-    }
-    return Format(
-        "$0 (error: $1)",
-        WriteBatchFormatter::FormatValue(key, value),
-        value_result.status());
+DocWriteBatchFormatter::DocWriteBatchFormatter(
+    StorageDbType storage_db_type,
+    BinaryOutputFormat binary_output_format,
+    WriteBatchOutputFormat batch_output_format,
+    std::string line_prefix)
+    : WriteBatchFormatter(binary_output_format,
+                          batch_output_format,
+                          std::move(line_prefix)),
+      storage_db_type_(storage_db_type) {
+}
+
+std::string DocWriteBatchFormatter::FormatKey(const Slice& key) {
+  const auto key_result = DocDBKeyToDebugStr(key, storage_db_type_);
+  if (key_result.ok()) {
+    return *key_result;
   }
+  return Format(
+      "$0 (error: $1)",
+      WriteBatchFormatter::FormatKey(key),
+      key_result.status());
+}
 
- private:
-  StorageDbType storage_db_type_;
-};
+std::string DocWriteBatchFormatter::FormatValue(const Slice& key, const Slice& value) {
+  auto key_type = GetKeyType(key, storage_db_type_);
+  const auto value_result = DocDBValueToDebugStr(
+      key_type, key, value, SchemaPackingStorage());
+  if (value_result.ok()) {
+    return *value_result;
+  }
+  return Format(
+      "$0 (error: $1)",
+      WriteBatchFormatter::FormatValue(key, value),
+      value_result.status());
+}
 
 Result<std::string> WriteBatchToString(
     const rocksdb::WriteBatch& write_batch,
diff --git a/src/yb/docdb/doc_write_batch.h b/src/yb/docdb/doc_write_batch.h
index 4aff56b51780..d43729840733 100644
--- a/src/yb/docdb/doc_write_batch.h
+++ b/src/yb/docdb/doc_write_batch.h
@@ -352,6 +352,23 @@ class DocWriteBatch {
   MonoDelta ttl_;
 };
 
+// A helper handler for converting a RocksDB write batch to a string.
+class DocWriteBatchFormatter : public WriteBatchFormatter {
+ public:
+  DocWriteBatchFormatter(
+      StorageDbType storage_db_type,
+      BinaryOutputFormat binary_output_format,
+      WriteBatchOutputFormat batch_output_format,
+      std::string line_prefix);
+ protected:
+  std::string FormatKey(const Slice& key) override;
+
+  std::string FormatValue(const Slice& key, const Slice& value) override;
+
+ private:
+  StorageDbType storage_db_type_;
+};
+
 // Converts a RocksDB WriteBatch to a string.
 // line_prefix is the prefix to be added to each line of the result. Could be used for indentation.
 Result<std::string> WriteBatchToString(
diff --git a/src/yb/docdb/rocksdb_writer.cc b/src/yb/docdb/rocksdb_writer.cc
index eef2b2ec7843..95b157d06674 100644
--- a/src/yb/docdb/rocksdb_writer.cc
+++ b/src/yb/docdb/rocksdb_writer.cc
@@ -448,7 +448,7 @@ ApplyIntentsContext::ApplyIntentsContext(
     rocksdb::DB* intents_db)
     : IntentsWriterContext(transaction_id),
       apply_state_(apply_state),
-      // In case we have passed in a non-null apply_state, it's aborted set will have been loaded
+      // In case we have passed in a non-null apply_state, its aborted set will have been loaded
       // from persisted apply state, and the passed in aborted set will correspond to the aborted
       // set at commit time. Rather then copy that set upstream so it is passed in as aborted, we
       // simply grab a reference to it here, if it is defined, to use in this method.
diff --git a/src/yb/docdb/transaction_dump.h b/src/yb/docdb/transaction_dump.h
index c1ada89f449e..a0deef4628df 100644
--- a/src/yb/docdb/transaction_dump.h
+++ b/src/yb/docdb/transaction_dump.h
@@ -19,6 +19,7 @@
 
 #include "yb/util/enums.h"
 #include "yb/util/slice.h"
+#include "yb/util/slice_parts.h"
 
 DECLARE_bool(dump_transactions);
 
diff --git a/src/yb/rocksdb/db/write_batch.cc b/src/yb/rocksdb/db/write_batch.cc
index 27f72b116066..4585a7c7f95f 100644
--- a/src/yb/rocksdb/db/write_batch.cc
+++ b/src/yb/rocksdb/db/write_batch.cc
@@ -58,6 +58,7 @@
 #include "yb/rocksdb/util/statistics.h"
 
 #include "yb/util/stats/perf_step_timer.h"
+#include "yb/util/faststring.h"
 
 namespace rocksdb {
 
@@ -104,15 +105,24 @@ struct BatchContentClassifier : public WriteBatch::Handler {
 
 class DirectWriteHandlerImpl : public DirectWriteHandler {
  public:
-  explicit DirectWriteHandlerImpl(MemTable* mem_table, SequenceNumber seq)
-      : mem_table_(mem_table), seq_(seq) {}
+  explicit DirectWriteHandlerImpl(
+      MemTable* mem_table, SequenceNumber seq, WriteBatch::Handler* handler_for_logging)
+      : mem_table_(mem_table), seq_(seq), handler_for_logging_(handler_for_logging) {}
 
   std::pair<Slice, Slice> Put(const SliceParts& key, const SliceParts& value) override {
+    if (handler_for_logging_) {
+      WARN_NOT_OK(handler_for_logging_->PutCF(0 /* column_family_id */, key, value),
+                  "Logging handler failed on PutCF");
+    }
     Add(ValueType::kTypeValue, key, value);
     return std::pair(prepared_add_.last_key, prepared_add_.last_value);
   }
 
   void SingleDelete(const Slice& key) override {
+    if (handler_for_logging_) {
+      WARN_NOT_OK(handler_for_logging_->SingleDeleteCF(0 /* column_family_id */, key),
+                  "Logging handler failed on SingleDeleteCF");
+    }
     if (mem_table_->Erase(key)) {
       return;
     }
@@ -142,6 +152,7 @@ class DirectWriteHandlerImpl : public DirectWriteHandler {
 
   MemTable* mem_table_;
   SequenceNumber seq_;
+  WriteBatch::Handler* handler_for_logging_;
   PreparedAdd prepared_add_;
   boost::container::small_vector<KeyHandle, 128> keys_;
 };
@@ -322,7 +333,8 @@ Status ReadRecordFromWriteBatch(Slice* input, char* tag,
   return Status::OK();
 }
 
-Result<size_t> DirectInsert(WriteBatch::Handler* handler, DirectWriter* writer);
+Result<size_t> DirectInsert(
+    WriteBatch::Handler* handler, DirectWriter* writer, WriteBatch::Handler* handler_for_logging);
 
 Status WriteBatch::Iterate(Handler* handler) const {
   Slice input(rep_);
@@ -339,7 +351,7 @@ Status WriteBatch::Iterate(Handler* handler) const {
     s = handler->Frontiers(*frontiers_);
   }
   if (s.ok() && direct_writer_) {
-    auto result = DirectInsert(handler, direct_writer_);
+    auto result = DirectInsert(handler, direct_writer_, handler_for_logging_);
     if (result.ok()) {
       direct_entries_ = *result;
     } else {
@@ -971,7 +983,8 @@ size_t WriteBatchInternal::AppendedByteSize(size_t leftByteSize,
   }
 }
 
-Result<size_t> DirectInsert(WriteBatch::Handler* handler, DirectWriter* writer) {
+Result<size_t> DirectInsert(
+    WriteBatch::Handler* handler, DirectWriter* writer, WriteBatch::Handler* handler_for_logging) {
   auto mem_table_inserter = down_cast<MemTableInserter*>(handler);
   auto* mems = mem_table_inserter->cf_mems_;
   auto current = mems->current();
@@ -980,7 +993,7 @@ Result<size_t> DirectInsert(WriteBatch::Handler* handler, DirectWriter* writer)
     current = mems->current();
   }
   DirectWriteHandlerImpl direct_write_handler(
-      current->mem(), mem_table_inserter->sequence_);
+      current->mem(), mem_table_inserter->sequence_, handler_for_logging);
   RETURN_NOT_OK(writer->Apply(&direct_write_handler));
   auto result = direct_write_handler.Complete();
   mem_table_inserter->CheckMemtableFull();
diff --git a/src/yb/rocksdb/util/coding.h b/src/yb/rocksdb/util/coding.h
index 71b2aec460fa..275552cd1b74 100644
--- a/src/yb/rocksdb/util/coding.h
+++ b/src/yb/rocksdb/util/coding.h
@@ -38,6 +38,7 @@
 
 #include "yb/util/cast.h"
 #include "yb/util/fast_varint.h"
+#include "yb/util/slice_parts.h"
 
 namespace rocksdb {
 
diff --git a/src/yb/rocksdb/write_batch.h b/src/yb/rocksdb/write_batch.h
index c46da2d65646..f0044cd66e8f 100644
--- a/src/yb/rocksdb/write_batch.h
+++ b/src/yb/rocksdb/write_batch.h
@@ -44,11 +44,13 @@
 #include <atomic>
 #include <string>
 #include <vector>
+#include <optional>
 
 #include "yb/rocksdb/status.h"
 #include "yb/rocksdb/write_batch_base.h"
 
 #include "yb/util/slice.h"
+#include "yb/util/slice_parts.h"
 
 namespace rocksdb {
 
@@ -65,9 +67,10 @@ class DirectWriteHandler {
   virtual ~DirectWriteHandler() = default;
 };
 
-// DirectWriter could be attached to WriteBatch, in this case when write batch is applied to
-// rocksdb, it calls direct writer passing DirectWriteHandler, that could be used to add
-// entries directly to mem table.
+// DirectWriter could be attached to a WriteBatch. In this case, when the write batch is written to
+// RocksDB, the Apply method of the direct writer is called, and it is passed a DirectWriteHandler.
+// The direct writer uses the methods of DirectWriteHandler such as Put and SingleDelete to write
+// entries directly to the memtable.
 class DirectWriter {
  public:
   virtual Status Apply(DirectWriteHandler* handler) = 0;
@@ -280,6 +283,10 @@ class WriteBatch : public WriteBatchBase {
     return direct_entries_;
   }
 
+  void SetHandlerForLogging(Handler* handler_for_logging) {
+    handler_for_logging_ = handler_for_logging;
+  }
+
  private:
   friend class WriteBatchInternal;
   std::unique_ptr<SavePoints> save_points_;
@@ -296,7 +303,7 @@ class WriteBatch : public WriteBatchBase {
   DirectWriter* direct_writer_ = nullptr;
   mutable size_t direct_entries_ = 0;
 
-  // Intentionally copyable
+  Handler* handler_for_logging_ = nullptr;
 };
 
 }  // namespace rocksdb
diff --git a/src/yb/rocksutil/write_batch_formatter.cc b/src/yb/rocksutil/write_batch_formatter.cc
index c08defa183fb..03eb111afec8 100644
--- a/src/yb/rocksutil/write_batch_formatter.cc
+++ b/src/yb/rocksutil/write_batch_formatter.cc
@@ -14,15 +14,12 @@
 
 #include "yb/rocksdb/metadata.h"
 #include "yb/util/bytes_formatter.h"
+#include "yb/util/kv_util.h"
 
 using std::endl;
 using rocksdb::Status;
 using rocksdb::SequenceNumber;
 
-using yb::FormatBytesAsStr;
-using yb::QuotesType;
-using yb::BinaryOutputFormat;
-
 namespace yb {
 
 rocksdb::Status WriteBatchFormatter::PutCF(
@@ -30,9 +27,13 @@ rocksdb::Status WriteBatchFormatter::PutCF(
     const SliceParts& key,
     const SliceParts& value) {
   StartOutputLine(__FUNCTION__);
-  OutputKey(key.TheOnlyPart());
+  KeyBuffer key_buffer;
+  Slice key_slice = key.AsSingleSlice(&key_buffer);
+  OutputKey(key_slice);
   AddSeparator();
-  OutputValue(key.TheOnlyPart(), value.TheOnlyPart());
+  ValueBuffer value_buffer;
+  Slice value_slice = value.AsSingleSlice(&value_buffer);
+  OutputValue(key_slice, value_slice);
   FinishOutputLine();
   return Status::OK();
 }
diff --git a/src/yb/rocksutil/write_batch_formatter.h b/src/yb/rocksutil/write_batch_formatter.h
index fa65165569b2..207b4111dbe9 100644
--- a/src/yb/rocksutil/write_batch_formatter.h
+++ b/src/yb/rocksutil/write_batch_formatter.h
@@ -69,6 +69,8 @@ class WriteBatchFormatter : public rocksdb::WriteBatch::Handler {
     line_prefix_ = line_prefix;
   }
 
+  int Count() { return kv_index_; }
+
  protected:
   virtual std::string FormatKey(const Slice& key);
 
diff --git a/src/yb/tablet/tablet.cc b/src/yb/tablet/tablet.cc
index 93fed760ffd5..fc56cff98c17 100644
--- a/src/yb/tablet/tablet.cc
+++ b/src/yb/tablet/tablet.cc
@@ -1413,6 +1413,14 @@ void Tablet::WriteToRocksDB(
   rocksdb::WriteOptions write_options;
   InitRocksDBWriteOptions(&write_options);
 
+  std::optional<docdb::DocWriteBatchFormatter> formatter;
+  if (FLAGS_TEST_docdb_log_write_batches) {
+    formatter.emplace(
+        storage_db_type, BinaryOutputFormat::kEscapedAndHex, WriteBatchOutputFormat::kArrow,
+        "  " + LogPrefix(storage_db_type));
+    write_batch->SetHandlerForLogging(&*formatter);
+  }
+
   auto rocksdb_write_status = dest_db->Write(write_options, write_batch);
   if (!rocksdb_write_status.ok()) {
     LOG_WITH_PREFIX(FATAL) << "Failed to write a batch with " << write_batch->Count()
@@ -1421,13 +1429,9 @@ void Tablet::WriteToRocksDB(
 
   if (FLAGS_TEST_docdb_log_write_batches) {
     LOG_WITH_PREFIX(INFO)
-        << "Wrote " << write_batch->Count() << " key/value pairs to " << storage_db_type
-        << " RocksDB:\n" << docdb::WriteBatchToString(
-            *write_batch,
-            storage_db_type,
-            BinaryOutputFormat::kEscapedAndHex,
-            WriteBatchOutputFormat::kArrow,
-            "  " + LogPrefix(storage_db_type));
+        << "Wrote " << formatter->Count()
+        << " key/value pairs to " << storage_db_type
+        << " RocksDB:\n" << formatter->str();
   }
 }
 
diff --git a/src/yb/util/CMakeLists.txt b/src/yb/util/CMakeLists.txt
index 92f00d588633..2bb99caf0621 100644
--- a/src/yb/util/CMakeLists.txt
+++ b/src/yb/util/CMakeLists.txt
@@ -227,6 +227,7 @@ set(UTIL_SRCS
   shared_mem.cc
   signal_util.cc
   slice.cc
+  slice_parts.cc
   spinlock_profiling.cc
   split.cc
   stack_trace.cc
diff --git a/src/yb/util/slice.cc b/src/yb/util/slice.cc
index 489de2048151..6c3bae67f5eb 100644
--- a/src/yb/util/slice.cc
+++ b/src/yb/util/slice.cc
@@ -30,6 +30,7 @@
 // under the License.
 //
 #include "yb/util/slice.h"
+#include "yb/util/slice_parts.h"
 
 #include "yb/util/status.h"
 #include "yb/util/status_format.h"
@@ -200,36 +201,4 @@ bool Slice::Contains(const Slice& rhs) const {
   return std::string_view(*this).find(rhs) != std::string::npos;
 }
 
-std::string SliceParts::ToDebugHexString() const {
-  std::string result;
-  for (int i = 0; i != num_parts; ++i) {
-    result += parts[i].ToDebugHexString();
-  }
-  return result;
-}
-
-size_t SliceParts::SumSizes() const {
-  size_t result = 0;
-  for (int i = 0; i != num_parts; ++i) {
-    result += parts[i].size();
-  }
-  return result;
-}
-
-char* SliceParts::CopyAllTo(char* out) const {
-  for (int i = 0; i != num_parts; ++i) {
-    if (!parts[i].size()) {
-      continue;
-    }
-    memcpy(out, parts[i].data(), parts[i].size());
-    out += parts[i].size();
-  }
-  return out;
-}
-
-Slice SliceParts::TheOnlyPart() const {
-  CHECK_EQ(num_parts, 1);
-  return parts[0];
-}
-
 }  // namespace yb
diff --git a/src/yb/util/slice.h b/src/yb/util/slice.h
index 7d2d33324815..d51a2a4c8e55 100644
--- a/src/yb/util/slice.h
+++ b/src/yb/util/slice.h
@@ -307,34 +307,6 @@ class Slice {
   // Intentionally copyable
 };
 
-struct SliceParts {
-  SliceParts(const Slice* _parts, int _num_parts) :
-      parts(_parts), num_parts(_num_parts) { }
-  SliceParts() : parts(nullptr), num_parts(0) {}
-
-  template<size_t N>
-  SliceParts(const std::array<Slice, N>& input) // NOLINT
-      : parts(input.data()), num_parts(N) {
-  }
-
-  std::string ToDebugHexString() const;
-
-  // Sum of sizes of all slices.
-  size_t SumSizes() const;
-
-  // Copy content of all slice to specified buffer.
-  void* CopyAllTo(void* out) const {
-    return CopyAllTo(static_cast<char*>(out));
-  }
-
-  char* CopyAllTo(char* out) const;
-
-  Slice TheOnlyPart() const;
-
-  const Slice* parts;
-  int num_parts;
-};
-
 inline bool operator==(const Slice& x, const Slice& y) {
   return ((x.size() == y.size()) &&
           (Slice::MemEqual(x.data(), y.data(), x.size())));
diff --git a/src/yb/util/slice_parts.cc b/src/yb/util/slice_parts.cc
new file mode 100644
index 000000000000..a06e2152136a
--- /dev/null
+++ b/src/yb/util/slice_parts.cc
@@ -0,0 +1,52 @@
+// Copyright (c) Yugabyte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+
+#include <glog/logging.h>
+
+#include "yb/util/slice.h"
+#include "yb/util/slice_parts.h"
+
+namespace yb {
+
+std::string SliceParts::ToDebugHexString() const {
+  std::string result;
+  for (int i = 0; i != num_parts; ++i) {
+    result += parts[i].ToDebugHexString();
+  }
+  return result;
+}
+
+size_t SliceParts::SumSizes() const {
+  size_t result = 0;
+  for (int i = 0; i != num_parts; ++i) {
+    result += parts[i].size();
+  }
+  return result;
+}
+
+char* SliceParts::CopyAllTo(char* out) const {
+  for (int i = 0; i != num_parts; ++i) {
+    if (!parts[i].size()) {
+      continue;
+    }
+    memcpy(out, parts[i].data(), parts[i].size());
+    out += parts[i].size();
+  }
+  return out;
+}
+
+Slice SliceParts::TheOnlyPart() const {
+  CHECK_EQ(num_parts, 1);
+  return parts[0];
+}
+
+}  // namespace yb
diff --git a/src/yb/util/slice_parts.h b/src/yb/util/slice_parts.h
new file mode 100644
index 000000000000..61a1abcf02ef
--- /dev/null
+++ b/src/yb/util/slice_parts.h
@@ -0,0 +1,72 @@
+// Copyright (c) Yugabyte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+
+#pragma once
+
+#include "yb/util/slice.h"
+#include "yb/util/byte_buffer.h"
+
+namespace yb {
+
+struct SliceParts {
+  SliceParts(const Slice* _parts, int _num_parts) :
+      parts(_parts), num_parts(_num_parts) { }
+  SliceParts() : parts(nullptr), num_parts(0) {}
+
+  template<size_t N>
+  SliceParts(const std::array<Slice, N>& input) // NOLINT
+      : parts(input.data()), num_parts(N) {
+  }
+
+  std::string ToDebugHexString() const;
+
+  // Sum of sizes of all slices.
+  size_t SumSizes() const;
+
+  // Copy content of all slice to specified buffer.
+  void* CopyAllTo(void* out) const {
+    return CopyAllTo(static_cast<char*>(out));
+  }
+
+  char* CopyAllTo(char* out) const;
+
+  Slice TheOnlyPart() const;
+
+  // Ensures that the combined data is available as a single slice. If there is zero or one part,
+  // no copying is done. Uses the given buffer for two or more parts. The buffer must be alive as
+  // long as the returned slice is being used.
+  template <size_t SmallLen>
+  Slice AsSingleSlice(ByteBuffer<SmallLen>* buffer) const {
+    if (num_parts == 0) {
+      return Slice();
+    }
+    if (num_parts == 1) {
+      return parts[0];
+    }
+    size_t size = SumSizes();
+    buffer->reserve(size);
+    uint8_t* dest = buffer->mutable_data();
+    CopyAllTo(dest);
+    return buffer->AsSlice();
+  }
+
+  const Slice* parts;
+  int num_parts;
+};
+
+}  // namespace yb
+
+namespace rocksdb {
+
+typedef yb::SliceParts SliceParts;
+
+}  // namespace rocksdb
